> ## Documentation Index
> Fetch the complete documentation index at: https://developer.box.com/llms.txt
> Use this file to discover all available pages before exploring further.

# 既存のタスクの変更

export const Link = ({href, children, className, ...props}) => {
  const localizedHref = localizeLink(href);
  return <a href={localizedHref} className={className} {...props}>
      {children}
    </a>;
};

export const MultiRelatedLinks = ({sections = []}) => {
  if (!sections || sections.length === 0) {
    return null;
  }
  return <div className="space-y-8">
      {sections.map((section, index) => <RelatedLinks key={index} title={section.title} items={section.items} />)}
    </div>;
};

export const RelatedLinks = ({title, items = []}) => {
  const getBadgeClass = badge => {
    if (!badge) return "badge-default";
    const badgeType = badge.toLowerCase().replace(/\s+/g, "-");
    return `badge-${badge === "ガイド" ? "guide" : badgeType}`;
  };
  if (!items || items.length === 0) {
    return null;
  }
  return <div className="my-8">
      {}
      <h3 className="text-sm font-bold uppercase tracking-wider mb-4">{title}</h3>

      {}
      <div className="flex flex-col gap-3">
        {items.map((item, index) => <a key={index} href={item.href} className="py-2 px-3 rounded related_link hover:bg-[#f2f2f2] dark:hover:bg-[#111827] flex items-center gap-3 group no-underline hover:no-underline border-b-0">
            {}
            <span className={`px-2 py-1 rounded-full text-xs font-semibold uppercase tracking-wide flex-shrink-0 ${getBadgeClass(item.badge)}`}>
              {item.badge}
            </span>

            {}
            <span className="text-base">{item.label}</span>
          </a>)}
      </div>
    </div>;
};

Boxでタスクを更新するには、タスクのIDを指定して<Link href="/reference/put-tasks-id">`PUT /tasks/:task_id`</Link> APIを呼び出す必要があります。このAPIを使用すると、タスクの`action`タイプの変更、`message`の追加、期日の変更を行うことができます。

<CodeGroup>
  ```sh cURL theme={null}
  curl -i -X PUT "https://api.box.com/2.0/tasks/12345" \
       -H "authorization: Bearer <ACCESS_TOKEN>" \
       -H "content-type: application/json" \
       -d '{
         "action": "review"
       }'
  ```

  ```typescript Node/TypeScript v10 theme={null}
  await client.tasks.updateTaskById(task.id!, {
    requestBody: {
      message: 'updated message',
    } satisfies UpdateTaskByIdRequestBody,
  } satisfies UpdateTaskByIdOptionalsInput);
  ```

  ```python Python v10 theme={null}
  client.tasks.update_task_by_id(task.id, message="updated message")
  ```

  ```csharp .NET v10 theme={null}
  await client.Tasks.UpdateTaskByIdAsync(taskId: NullableUtils.Unwrap(task.Id), requestBody: new UpdateTaskByIdRequestBody() { Message = "updated message" });
  ```

  ```swift Swift v10 theme={null}
  try await client.tasks.updateTaskById(taskId: task.id!, requestBody: UpdateTaskByIdRequestBody(message: "updated message"))
  ```

  ```java Java v10 theme={null}
  client.getTasks().updateTaskById(task.getId(), new UpdateTaskByIdRequestBody.Builder().message("updated message").build())
  ```

  ```java Java v5 theme={null}
  BoxTask task = new BoxTask(api, "id");
  BoxTask.Info info = task.new Info();
  info.setMessage("An edited message.");
  task.updateInfo(info);
  ```

  ```py Python v4 theme={null}
  task_update = {'message': 'New Message', 'due_at': '2014-04-03T11:09:43-10:00'}
  updated_task = client.task(task_id='12345').update_info(data=task_update)
  print(f'New task message is {updated_task.message} and the new due time is {updated_task.due_at}')
  ```

  ```csharp .NET v6 theme={null}
  var updates = new BoxTaskUpdateRequest()
  {
      Id = "22222",
      Message = "Could you please review this?"
  };
  BoxTask updatedTask = await client.TasksManager.UpdateTaskAsync(updates);
  ```

  ```js Node v4 theme={null}
  client.tasks.update('11111', { message: 'Could you please review?' })
   .then(task => {
    /* task -> {
     type: 'task',
     id: '11111',
     item: 
     { type: 'file',
      id: '22222',
      sequence_id: '0',
      etag: '0',
      sha1: '0bbd79a105c504f99573e3799756debba4c760cd',
      name: 'box-logo.png' },
     due_at: '2014-04-03T11:09:43-07:00',
     action: 'review',
     message: 'Could you please review?',
     task_assignment_collection: { total_count: 0, entries: [] },
     is_completed: false,
     created_by: 
     { type: 'user',
      id: '33333',
      name: 'Example User',
      login: 'user@example.com' },
     created_at: '2013-04-03T11:12:54-07:00' }
    */
   });
  ```
</CodeGroup>

## タスクのアクション

Boxは現在、`action`値によって定義される、`review`と`complete`という2種類のタスクをサポートしています。

タスクのタイプによって、タスクがなりうる解決状態と、ウェブアプリおよびモバイルアプリでユーザーに表示されるインターフェースが決まります。

| タスクのアクション  | 考えられる解決状態                            |
| ---------- | ------------------------------------ |
| `review`   | `incomplete`, `approved`, `rejected` |
| `complete` | `incomplete`, `complete`             |

`review`タスクは`incomplete`状態で開始され、`incomplete`、`approved`、または`rejected`としてマークすることができます。ユーザーインターフェースには、テキストボックスのほか、タスクを承認または拒否する1組のボタンが表示されます。

`complete`タスクは`incomplete`状態で開始され、`incomplete`または`completed`としてマークすることができます。このタスクが完了としてマークされると、タスクの状態をそれ以上変更することはできなくなります。ユーザーインターフェースには、テキストボックスのほか、タスクを完了としてマークするためのボタンが表示されます。

## 完了のルール

ファイルに関連するタスクは、そのファイルの複数のコラボレータに割り当てることができます。また、タスクの`completion_rule`を使用すると、タスクを完了する必要があるのはタスクが割り当てられているすべてのユーザー (`all_assignees`) か1人の担当者のみ (`any_assignee`) かを定義できます。

<RelatedLinks
  title="関連するAPI"
  items={[
{ label: translate("Update task"), href: "/reference/put-tasks-id", badge: "PUT" }
]}
/>

<RelatedLinks
  title="関連するガイド"
  items={[
{ label: translate("Create a task"), href: "/guides/tasks/create", badge: "GUIDE" },
{ label: translate("Get information about a task"), href: "/guides/tasks/get", badge: "GUIDE" },
{ label: translate("Delete a task"), href: "/guides/tasks/delete", badge: "GUIDE" }
]}
/>
